diff --git a/src/odbc/unittests/compute.c b/src/odbc/unittests/compute.c
index 11c0548..20bca06 100644
--- a/src/odbc/unittests/compute.c
+++ b/src/odbc/unittests/compute.c
@@ -9,7 +9,7 @@
  * and declared in odbcss.h
  */
 
-static char software_version[] = "$Id: compute.c,v 1.10 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: compute.c,v 1.11 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char col1[256], col2[256];
@@ -35,14 +35,14 @@ TestName(SQLSMALLINT index, const char *expected_name)
 	} while(0)
 
 	/* retrieve with SQLDescribeCol */
-	CHK(SQLDescribeCol, (Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL));
+	CHKDescribeCol(index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL, "S");
 	NAME_TEST;
 
 	/* retrieve with SQLColAttribute */
-	CHK(SQLColAttribute, (Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL));
+	CHKColAttribute(index, SQL_DESC_NAME, name, sizeof(name), &len, NULL, "S");
 	if (db_is_microsoft())
 		NAME_TEST;
-	CHK(SQLColAttribute, (Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL));
+	CHKColAttribute(index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL, "S");
 	NAME_TEST;
 }
 
@@ -53,7 +53,7 @@ CheckFetch(const char *c1name, const char *c1, const char *c2)
 
 	TestName(1, c1name);
 
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 
 	if (strlen(c1) != ind1 || strcmp(c1, col1) != 0) {
 		fprintf(stderr, "%s:%d: Column 1 error '%s' (%d) expected '%s' (%d)\n", __FILE__, main_line, col1, (int) ind1, c1,
@@ -101,19 +101,16 @@ main(int argc, char *argv[])
 	CheckFetch("c", "pluto", "1");
 	CheckFetch("c", "pluto", "2");
 	CheckFetch("c", "pluto", "3");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	CHK(SQLMoreResults, (Statement));
+	CHKFetch("No");
+	CHKMoreResults("S");
 
 	/* why I need to rebind ?? ms bug of feature ?? */
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
 	col2[0] = '@';
 	CheckFetch("sum", "52", "@");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
+	CHKFetch("No");
+	CHKMoreResults("No");
 
 
 
@@ -124,43 +121,37 @@ main(int argc, char *argv[])
 	Command(Statement, "select c as mao, i from #tmp1 order by c, i compute sum(i) by c compute max(i)");
 	CheckFetch("mao", "pippo", "12");
 	CheckFetch("mao", "pippo", "34");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	CHK(SQLMoreResults, (Statement));
+	CHKFetch("No");
+	CHKMoreResults("S");
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
 	strcpy(col2, "##");
 	CheckFetch("sum", "46", "##");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	CHK(SQLMoreResults, (Statement));
+	CHKFetch("No");
+	CHKMoreResults("S");
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
 	CheckFetch("mao", "pluto", "1");
 	CheckFetch("mao", "pluto", "2");
 	CheckFetch("mao", "pluto", "3");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	CHK(SQLMoreResults, (Statement));
+	CHKFetch("No");
+	CHKMoreResults("S");
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
 	strcpy(col2, "%");
 	CheckFetch("sum", "6", "%");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	CHK(SQLMoreResults, (Statement));
+	CHKFetch("No");
+	CHKMoreResults("S");
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
 	strcpy(col2, "&");
 	CheckFetch("max", "34", "&");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
+	CHKFetch("No");
+	CHKMoreResults("No");
 
 
 
@@ -171,23 +162,20 @@ main(int argc, char *argv[])
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
 	Command(Statement, "select * from #tmp1 where i = 2 or i = 34 order by c, i compute min(i) by c");
 	CheckFetch("c", "pippo", "34");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	CHK(SQLMoreResults, (Statement));
+	CHKFetch("No");
+	CHKMoreResults("S");
 
 	/* here just skip results, before a row */
-	CHK(SQLMoreResults, (Statement));
+	CHKMoreResults("S");
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
 	CheckFetch("c", "pluto", "2");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
-	CHK(SQLMoreResults, (Statement));
+	CHKFetch("No");
+	CHKMoreResults("S");
 
 	/* here just skip results, before done */
-	if (SQLMoreResults(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Still data ??");
+	CHKMoreResults("No");
 
 
 	Disconnect();
diff --git a/src/odbc/unittests/connect.c b/src/odbc/unittests/connect.c
index b897544..1d1537d 100644
--- a/src/odbc/unittests/connect.c
+++ b/src/odbc/unittests/connect.c
@@ -1,7 +1,7 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: connect.c,v 1.9 2006/04/11 11:52:24 freddy77 Exp $";
+static char software_version[] = "$Id: connect.c,v 1.10 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -9,21 +9,13 @@ static void init_connect(void);
 static void
 init_connect(void)
 {
-	if (SQLAllocEnv(&Environment) != SQL_SUCCESS) {
-		printf("Unable to allocate env\n");
-		exit(1);
-	}
-	if (SQLAllocConnect(Environment, &Connection) != SQL_SUCCESS) {
-		printf("Unable to allocate connection\n");
-		SQLFreeEnv(Environment);
-		exit(1);
-	}
+	CHKR(SQLAllocEnv, (&Environment), "S");
+	CHKR(SQLAllocConnect, (Environment, &Connection), "S");
 }
 
 int
 main(int argc, char *argv[])
 {
-	int res;
 	char tmp[2048];
 	SQLSMALLINT len;
 	int failures = 0;
@@ -66,12 +58,7 @@ main(int argc, char *argv[])
 	printf("connect string DSN connect..\n");
 	init_connect();
 	sprintf(tmp, "DSN=%s;UID=%s;PWD=%s;DATABASE=%s;", SERVER, USER, PASSWORD, DATABASE);
-	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
-		CheckReturn();
-		return 1;
-	}
+	CHKR(SQLDriverConnect, (Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT), "SI");
 	Disconnect();
 
 	/* try connect string using old SERVERNAME specification */
@@ -81,9 +68,9 @@ main(int argc, char *argv[])
 	/* this is expected to work with unixODBC */
 	init_connect();
 	sprintf(tmp, "DRIVER=FreeTDS;SERVERNAME=%s;UID=%s;PWD=%s;DATABASE=%s;", SERVER, USER, PASSWORD, DATABASE);
-	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
-	if (!SQL_SUCCEEDED(res)) {
-		printf("Unable to open data source (ret=%d)\n", res);
+	CHKR(SQLDriverConnect, (Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT), "SIE");
+	if (RetCode == SQL_ERROR) {
+		printf("Unable to open data source (ret=%d)\n", RetCode);
 		++failures;
 	}
 	Disconnect();
@@ -91,9 +78,9 @@ main(int argc, char *argv[])
 	/* this is expected to work with iODBC */
 	init_connect();
 	sprintf(tmp, "DRIVER=%s;SERVERNAME=%s;UID=%s;PWD=%s;DATABASE=%s;", DRIVER, SERVER, USER, PASSWORD, DATABASE);
-	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
-	if (!SQL_SUCCEEDED(res)) {
-		printf("Unable to open data source (ret=%d)\n", res);
+	CHKR(SQLDriverConnect, (Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT), "SIE");
+	if (RetCode == SQL_ERROR) {
+		printf("Unable to open data source (ret=%d)\n", RetCode);
 		++failures;
 	}
 	Disconnect();
diff --git a/src/odbc/unittests/connect2.c b/src/odbc/unittests/connect2.c
index 0f00546..9eacb7b 100644
--- a/src/odbc/unittests/connect2.c
+++ b/src/odbc/unittests/connect2.c
@@ -5,7 +5,7 @@
  * either SQLConnect and SQLDriverConnect
  */
 
-static char software_version[] = "$Id: connect2.c,v 1.5 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: connect2.c,v 1.6 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int failed = 0;
@@ -15,27 +15,14 @@ static void init_connect(void);
 static void
 init_connect(void)
 {
-	if (SQLAllocEnv(&Environment) != SQL_SUCCESS) {
-		printf("Unable to allocate env\n");
-		exit(1);
-	}
-	if (SQLAllocConnect(Environment, &Connection) != SQL_SUCCESS) {
-		printf("Unable to allocate connection\n");
-		SQLFreeEnv(Environment);
-		exit(1);
-	}
+	CHKR(SQLAllocEnv, (&Environment), "S");
+	CHKR(SQLAllocConnect, (Environment, &Connection), "S");
 }
 
 static void
 normal_connect(void)
 {
-	int res;
-
-	res = SQLConnect(Connection, (SQLCHAR *) SERVER, SQL_NTS, (SQLCHAR *) USER, SQL_NTS, (SQLCHAR *) PASSWORD, SQL_NTS);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
-		CheckReturn();
-	}
+	CHKR(SQLConnect, (Connection, (SQLCHAR *) SERVER, SQL_NTS, (SQLCHAR *) USER, SQL_NTS, (SQLCHAR *) PASSWORD, SQL_NTS), "SI");
 }
 
 static void
@@ -43,13 +30,8 @@ driver_connect(const char *conn_str)
 {
 	char tmp[1024];
 	SQLSMALLINT len;
-	int res;
 
-	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) conn_str, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
-		CheckReturn();
-	}
+	CHKR(SQLDriverConnect, (Connection, NULL, (SQLCHAR *) conn_str, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT), "SI");
 }
 
 static void
@@ -57,14 +39,9 @@ check_dbname(const char *dbname)
 {
 	SQLINTEGER len;
 	char out[512];
-	int res;
 
 	len = sizeof(out);
-	res = SQLGetConnectAttr(Connection, SQL_ATTR_CURRENT_CATALOG, (SQLPOINTER) out, sizeof(out), &len);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to get database name to %s\n", dbname);
-		CheckReturn();
-	}
+	CHKGetConnectAttr(SQL_ATTR_CURRENT_CATALOG, (SQLPOINTER) out, sizeof(out), &len, "SI");
 
 	if (strcmp(out, dbname) != 0) {
 		fprintf(stderr, "Current database (%s) is not %s\n", out, dbname);
@@ -75,20 +52,13 @@ check_dbname(const char *dbname)
 static void
 set_dbname(const char *dbname)
 {
-	int res;
-
-	res = SQLSetConnectAttr(Connection, SQL_ATTR_CURRENT_CATALOG, (SQLPOINTER) dbname, strlen(dbname));
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to set database name to %s\n", dbname);
-		CheckReturn();
-	}
+	CHKSetConnectAttr(SQL_ATTR_CURRENT_CATALOG, (SQLPOINTER) dbname, strlen(dbname), "SI");
 }
 
 int
 main(int argc, char *argv[])
 {
 	char tmp[1024];
-	int res;
 
 	if (read_login_info())
 		exit(1);
@@ -107,11 +77,7 @@ main(int argc, char *argv[])
 
 	printf("SQLConnect after not existing..\n");
 	strcpy(tmp, "IDontExist");
-	res = SQLSetConnectAttr(Connection, SQL_ATTR_CURRENT_CATALOG, (SQLPOINTER) tmp, strlen(tmp));
-	if (res != SQL_ERROR) {
-		fprintf(stderr, "SQLSetConnectAttr should fail\n");
-		return 1;
-	}
+	CHKSetConnectAttr(SQL_ATTR_CURRENT_CATALOG, (SQLPOINTER) tmp, strlen(tmp), "E");
 	check_dbname("tempdb");
 
 	Disconnect();
diff --git a/src/odbc/unittests/const_params.c b/src/odbc/unittests/const_params.c
index a1482e1..92bbbf2 100644
--- a/src/odbc/unittests/const_params.c
+++ b/src/odbc/unittests/const_params.c
@@ -2,7 +2,7 @@
 
 /* Test for {?=call store(?,123,'foo')} syntax and run */
 
-static char software_version[] = "$Id: const_params.c,v 1.14 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: const_params.c,v 1.15 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -26,17 +26,16 @@ main(int argc, char *argv[])
 		" return 24680\n"
 		"end");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind));
-
-	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1, 0, &ind2));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind, "S");
+	CHKBindParameter(2, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1, 0, &ind2, "S");
 
 	/* TODO use {ts ...} for date */
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{call const_param(?, 13579, '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "{call const_param(?, 13579, '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS, "S");
 
 	input = 13579;
 	ind = sizeof(input);
 	out1 = output = 0xdeadbeef;
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
 	if (out1 != 7654321) {
 		fprintf(stderr, "Invalid output %d (0x%x)\n", (int) out1, (int) out1);
@@ -46,17 +45,17 @@ main(int argc, char *argv[])
 	/* just to reset some possible buffers */
 	Command(Statement, "DECLARE @i INT");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
-	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0, 0, &input,  0, &ind2));
-	CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1,   0, &ind3));
+	CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind,  "S");
+	CHKBindParameter(2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0, 0, &input,  0, &ind2, "S");
+	CHKBindParameter(3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1,   0, &ind3, "S");
 
 	/* TODO use {ts ...} for date */
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{?=call const_param(?, , '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "{?=call const_param(?, , '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS, "S");
 
 	input = 13579;
 	ind2 = sizeof(input);
 	out1 = output = 0xdeadbeef;
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
 	if (out1 != 7654321) {
 		fprintf(stderr, "Invalid output %d (0x%x)\n", (int) out1, (int) out1);
@@ -77,12 +76,12 @@ main(int argc, char *argv[])
 		" return 54321\n"
 		"end");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
+	CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind, "S");
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{?=call const_param(12.5, 0x0102030405060708)}", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "{?=call const_param(12.5, 0x0102030405060708)}", SQL_NTS, "S");
 
 	output = 0xdeadbeef;
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
 	if (output != 54321) {
 		fprintf(stderr, "Invalid result %d (0x%x) expected 54321\n", (int) output, (int) output);
@@ -100,7 +99,7 @@ main(int argc, char *argv[])
 	/* catch problem reported by Peter Deacon */
 	output = 0xdeadbeef;
 	Command(Statement, "{CALL const_param('value')}");
-	CHK(SQLBindCol, (Statement, 1, SQL_C_SLONG, &output, 0, &ind));
+	CHKBindCol(1, SQL_C_SLONG, &output, 0, &ind, "S");
 	SQLFetch(Statement);
 
 	if (output != 8421) {
diff --git a/src/odbc/unittests/convert_error.c b/src/odbc/unittests/convert_error.c
index 68a70ef..676adf0 100644
--- a/src/odbc/unittests/convert_error.c
+++ b/src/odbc/unittests/convert_error.c
@@ -4,7 +4,7 @@
  */
 #include "common.h"
 
-static char software_version[] = "$Id: convert_error.c,v 1.8 2008/01/31 09:13:08 freddy77 Exp $";
+static char software_version[] = "$Id: convert_error.c,v 1.9 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int test_num = 0;
@@ -22,13 +22,13 @@ Test(const char *bind1, SQLSMALLINT type1, const char *bind2, SQLSMALLINT type2)
 	++test_num;
 	sprintf(sql, "insert into #test_output values (%s, %s)", bind1, bind2);
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) sql, strlen(sql)));
+	CHKPrepare((SQLCHAR *) sql, strlen(sql), "S");
 	if (bind1[0] == '?')
-		CHK(SQLBindParameter, (Statement, id++, SQL_PARAM_INPUT, SQL_C_LONG, type1, 3, 0, &test_num, 0, &ind));
+		CHKBindParameter(id++, SQL_PARAM_INPUT, SQL_C_LONG, type1, 3, 0, &test_num, 0, &ind, "S");
 	if (bind2[0] == '?')
-		CHK(SQLBindParameter, (Statement, id++, SQL_PARAM_INPUT, SQL_C_CHAR, type2, strlen(val) + 1, 0, (SQLCHAR *) val,
-					 0, &ind));
-	CHK(SQLExecute, (Statement));
+		CHKBindParameter(id++, SQL_PARAM_INPUT, SQL_C_CHAR, type2, strlen(val) + 1, 0, (SQLCHAR *) val,
+					 0, &ind, "S");
+	CHKExecute("S");
 }
 
 int
diff --git a/src/odbc/unittests/copydesc.c b/src/odbc/unittests/copydesc.c
index 75380bc..9488154 100644
--- a/src/odbc/unittests/copydesc.c
+++ b/src/odbc/unittests/copydesc.c
@@ -2,7 +2,7 @@
 
 /* Test SQLCopyDesc and SQLAllocHandle(SQL_HANDLE_DESC) */
 
-static char software_version[] = "$Id: copydesc.c,v 1.4 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: copydesc.c,v 1.5 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -15,20 +15,20 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	CHK(SQLGetStmtAttr, (Statement, SQL_ATTR_APP_ROW_DESC, &ard, 0, NULL));
+	CHKGetStmtAttr(SQL_ATTR_APP_ROW_DESC, &ard, 0, NULL, "S");
 
-	CHK(SQLBindCol, (Statement, 1, SQL_C_SLONG, &id, sizeof(SQLINTEGER), &ind1));
-	CHK(SQLBindCol, (Statement, 2, SQL_C_CHAR, name, sizeof(name), &ind2));
+	CHKBindCol(1, SQL_C_SLONG, &id, sizeof(SQLINTEGER), &ind1, "S");
+	CHKBindCol(2, SQL_C_CHAR, name, sizeof(name), &ind2, "S");
 
-	CHK(SQLAllocHandle, (SQL_HANDLE_DESC, Connection, &ard2));
+	CHKAllocHandle(SQL_HANDLE_DESC, Connection, &ard2, "S");
 
 	/*
 	 * this is an additional test to test additional allocation 
 	 * As of 0.64 for a bug in SQLAllocDesc we only allow to allocate one
 	 */
-	CHK(SQLAllocHandle, (SQL_HANDLE_DESC, Connection, &ard3));
+	CHKAllocHandle(SQL_HANDLE_DESC, Connection, &ard3, "S");
 
-	CHK(SQLCopyDesc, (ard, ard2));
+	CHKR(SQLCopyDesc, (ard, ard2), "S");
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/cursor1.c b/src/odbc/unittests/cursor1.c
index 1882457..e19fb2c 100644
--- a/src/odbc/unittests/cursor1.c
+++ b/src/odbc/unittests/cursor1.c
@@ -2,14 +2,9 @@
 
 /* Test cursors */
 
-static char software_version[] = "$Id: cursor1.c,v 1.16 2008/10/31 14:35:23 freddy77 Exp $";
+static char software_version[] = "$Id: cursor1.c,v 1.17 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#define CHK_INFO(func,params) \
-	do { if (!SQL_SUCCEEDED(func params)) \
-		ODBC_REPORT_ERROR(#func); \
-	} while(0)
-
 #define SWAP_STMT(b) do { SQLHSTMT xyz = Statement; Statement = b; b = xyz; } while(0)
 
 static int mssql2005 = 0;
@@ -17,26 +12,22 @@ static int mssql2005 = 0;
 static void
 CheckNoRow(const char *query)
 {
-	SQLRETURN retcode;
+	SQLRETURN RetCode;
 
-	retcode = SQLExecDirect(Statement, (SQLCHAR *) query, SQL_NTS);
-	if (retcode == SQL_NO_DATA)
+	CHKExecDirect((SQLCHAR *) query, SQL_NTS, "SINo");
+	if (RetCode == SQL_NO_DATA)
 		return;
 
-	if (!SQL_SUCCEEDED(retcode))
-		ODBC_REPORT_ERROR("SQLExecDirect");
-
 	do {
 		SQLSMALLINT cols;
 
-		retcode = SQLNumResultCols(Statement, &cols);
-		if (retcode != SQL_SUCCESS || cols != 0) {
+		CHKNumResultCols(&cols, "S");
+		if (cols != 0) {
 			fprintf(stderr, "Data not expected here, query:\n\t%s\n", query);
+			Disconnect();
 			exit(1);
 		}
-	} while ((retcode = SQLMoreResults(Statement)) == SQL_SUCCESS);
-	if (retcode != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("SQLMoreResults");
+	} while (CHKMoreResults("SNo") == SQL_SUCCESS);
 }
 
 static void
@@ -53,7 +44,7 @@ Test0(int use_sql, const char *create_sql, const char *insert_sql, const char *s
 	SQLUSMALLINT i;
 	SQLULEN num_row;
 	SQLHSTMT stmt2;
-	SQLRETURN retcode;
+	SQLRETURN RetCode;
 
 	/* create test table */
 	Command(Statement, "IF OBJECT_ID('tempdb..#test') IS NOT NULL DROP TABLE #test");
@@ -68,27 +59,24 @@ Test0(int use_sql, const char *create_sql, const char *insert_sql, const char *s
 
 	/* set cursor options */
 	ResetStatement();
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_ROWVER, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_ARRAY_SIZE, (SQLPOINTER) ROWS, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_STATUS_PTR, (SQLPOINTER) statuses, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0));
-	CHK(SQLSetCursorName, (Statement, (SQLCHAR *) "C1", SQL_NTS));
+	CHKSetStmtAttr(SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_ROWVER, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_ARRAY_SIZE, (SQLPOINTER) ROWS, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_STATUS_PTR, (SQLPOINTER) statuses, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0, "S");
+	CHKSetCursorName((SQLCHAR *) "C1", SQL_NTS, "S");
 
 	/* */
-	CHK(SQLExecDirect, (Statement, (SQLCHAR *) select_sql, SQL_NTS));
+	CHKExecDirect((SQLCHAR *) select_sql, SQL_NTS, "S");
 
 	/* bind some rows at a time */
-	CHK(SQLBindCol, (Statement, 1, SQL_C_ULONG, n, 0, n_len));
-	CHK(SQLBindCol, (Statement, 2, SQL_C_CHAR, c, C_LEN, c_len));
+	CHKBindCol(1, SQL_C_ULONG, n, 0, n_len, "S");
+	CHKBindCol(2, SQL_C_CHAR, c, C_LEN, c_len, "S");
 
 	/* allocate an additional statement */
-	CHK(SQLAllocStmt, (Connection, &stmt2));
-
-	while ((retcode = SQLFetchScroll(Statement, SQL_FETCH_NEXT, 0)) != SQL_ERROR) {
-		if (retcode == SQL_NO_DATA)
-			break;
+	CHKAllocStmt(&stmt2, "S");
 
+	while (CHKFetchScroll(SQL_FETCH_NEXT, 0, "SNo") == SQL_SUCCESS) {
 		/* print, just for debug */
 		for (i = 0; i < num_row; ++i)
 			printf("row %d i %d c %s\n", (int) (i + 1), (int) n[i], c[i]);
@@ -98,13 +86,13 @@ Test0(int use_sql, const char *create_sql, const char *insert_sql, const char *s
 		i = 1;
 		if (i > 0 && i <= num_row) {
 			if (mssql2005)
-				CHK_INFO(SQLSetPos, (Statement, i, use_sql ? SQL_POSITION : SQL_DELETE, SQL_LOCK_NO_CHANGE));
+				CHKSetPos(i, use_sql ? SQL_POSITION : SQL_DELETE, SQL_LOCK_NO_CHANGE, "SI");
 			else
-				CHK(SQLSetPos, (Statement, i, use_sql ? SQL_POSITION : SQL_DELETE, SQL_LOCK_NO_CHANGE));
+				CHKSetPos(i, use_sql ? SQL_POSITION : SQL_DELETE, SQL_LOCK_NO_CHANGE, "S");
 			if (use_sql) {
 				SWAP_STMT(stmt2);
-				CHK(SQLPrepare, (Statement, (SQLCHAR *) "DELETE FROM #test WHERE CURRENT OF C1", SQL_NTS));
-				CHK(SQLExecute, (Statement));
+				CHKPrepare((SQLCHAR *) "DELETE FROM #test WHERE CURRENT OF C1", SQL_NTS, "S");
+				CHKExecute("S");
 				SWAP_STMT(stmt2);
 			}
 		}
@@ -115,19 +103,15 @@ Test0(int use_sql, const char *create_sql, const char *insert_sql, const char *s
 			strcpy(c[i - 1], "foo");
 			c_len[i - 1] = 3;
 			if (strstr(select_sql, "#a") == NULL || use_sql) {
-				CHK(SQLSetPos, (Statement, i, use_sql ? SQL_POSITION : SQL_UPDATE, SQL_LOCK_NO_CHANGE));
+				CHKSetPos(i, use_sql ? SQL_POSITION : SQL_UPDATE, SQL_LOCK_NO_CHANGE, "S");
 			} else {
 				unsigned char sqlstate[6];
 				unsigned char msg[256];
 
 				n[i - 1] = 321;
-				retcode = SQLSetPos(Statement, i, use_sql ? SQL_POSITION : SQL_UPDATE, SQL_LOCK_NO_CHANGE);
-				if (retcode != SQL_ERROR) {
-					fprintf(stderr, "Error expected at line %d\n", __LINE__);
-					exit(1);
-				}
+				CHKSetPos(i, use_sql ? SQL_POSITION : SQL_UPDATE, SQL_LOCK_NO_CHANGE, "E");
 
-				CHK(SQLGetDiagRec, (SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, msg, sizeof(msg), NULL));
+				CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, msg, sizeof(msg), NULL, "S");
 				if (strstr((char *) msg, "Invalid column name 'c'") == NULL) {
 					fprintf(stderr, "Expected message not found at line %d\n", __LINE__);
 					exit(1);
@@ -135,10 +119,9 @@ Test0(int use_sql, const char *create_sql, const char *insert_sql, const char *s
 			}
 			if (use_sql) {
 				SWAP_STMT(stmt2);
-				CHK(SQLPrepare, (Statement, (SQLCHAR *) "UPDATE #test SET c=? WHERE CURRENT OF C1", SQL_NTS));
-				CHK(SQLBindParameter,
-				    (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, C_LEN, 0, c[i - 1], 0, NULL));
-				CHK(SQLExecute, (Statement));
+				CHKPrepare((SQLCHAR *) "UPDATE #test SET c=? WHERE CURRENT OF C1", SQL_NTS, "S");
+				CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, C_LEN, 0, c[i - 1], 0, NULL, "S");
+				CHKExecute("S");
 				/* FIXME this is not necessary for mssql driver */
 				SQLMoreResults(Statement);
 				SWAP_STMT(stmt2);
@@ -146,10 +129,9 @@ Test0(int use_sql, const char *create_sql, const char *insert_sql, const char *s
 		}
 	}
 
-	if (retcode == SQL_ERROR)
-		ODBC_REPORT_ERROR("SQLFetchScroll");
-
-	CHK(SQLFreeStmt, (stmt2, SQL_DROP));
+	SWAP_STMT(stmt2);
+	CHKFreeStmt(SQL_DROP, "S");
+	SWAP_STMT(stmt2);
 
 	ResetStatement();
 
diff --git a/src/odbc/unittests/cursor2.c b/src/odbc/unittests/cursor2.c
index ac1d1db..9d261f6 100644
--- a/src/odbc/unittests/cursor2.c
+++ b/src/odbc/unittests/cursor2.c
@@ -2,7 +2,7 @@
 
 /* Test cursor do not give error for statement that do not return rows  */
 
-static char software_version[] = "$Id: cursor2.c,v 1.4 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: cursor2.c,v 1.5 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -18,7 +18,7 @@ main(int argc, char *argv[])
 
 	retcode = SQLSetConnectAttr(Connection, SQL_ATTR_CURSOR_TYPE,  (SQLPOINTER) SQL_CURSOR_DYNAMIC, SQL_IS_INTEGER);
 	if (retcode != SQL_SUCCESS) {
-		CHK(SQLGetDiagRec, (SQL_HANDLE_DBC, Connection, 1, sqlstate, NULL, (SQLCHAR *) msg, sizeof(msg), NULL));
+		CHKGetDiagRec(SQL_HANDLE_DBC, Connection, 1, sqlstate, NULL, (SQLCHAR *) msg, sizeof(msg), NULL, "S");
 		sqlstate[5] = 0;
 		if (strcmp((const char*) sqlstate, "S1092") == 0) {
 			printf("Your connection seems to not support cursors, probably you are using wrong protocol version or Sybase\n");
@@ -33,8 +33,7 @@ main(int argc, char *argv[])
 	/* this should not fail or return warnings */
 	Command(Statement, "DROP TABLE #cursor2_test");
 
-	if (SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, msg, sizeof(msg), NULL) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("no warning expected");
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, msg, sizeof(msg), NULL, "No");
 
 	Disconnect();
 	
